image: docker:stable

stages:
  - build
  - test
  - release
  - publish

variables:
  IMAGE: ${CI_REGISTRY}/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}

include:
  remote: "https://gitlab.com/cublueprint/tools/ci/-/raw/main/Release.gitlab-ci.yml"

build:client:
  stage: build
  only:
    - merge_requests
    - main
    - dev
  services:
    - docker:dind
  variables:
    DOCKER_DRIVER: overlay2
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker pull $IMAGE:client || true
    - docker build --cache-from $IMAGE:client --tag $IMAGE:client --file ./Dockerfile .
    - docker push $IMAGE:client

test:client:
  stage: test
  needs: ["build:client"]
  only:
    - merge_requests
    - main
    - dev
  image: node:14-alpine
  variables:
    NODE_ENV: test
  script:
    - yarn install
    - yarn test:ci
  artifacts:
    when: always
    reports:
      cobertura:
        - coverage/cobertura-coverage.xml
      junit:
        - coverage/junit.xml

publish:client:
  stage: publish
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule" && $IS_PUBLISH == "false"
      when: manual
    - if: $CI_PIPELINE_SOURCE == "schedule" && $IS_PUBLISH == "true"
      when: on_success
  image: node:14
  variables:
    NODE_ENV: production
  script:
    - eval $(ssh-agent -s)
    - echo "$DEPLOY_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - git config --global user.email "gitlab-runner@gitlab.com"
    - git config --global user.name "Gitlab Runner"
    - PACKAGE_VERSION=$(cat package.json | grep version | head -1 | awk -F= "{ print $2 }" | sed 's/[version:,\",]//g' | tr -d '[[:space:]]')
    - yarn install
    - CI=false yarn build
    - git clone git@gitlab.com:cublueprint/beneficent/nginx.git
    - rm -rf ./nginx/static/build
    - cp -r ./build ./nginx/static/
    - cd nginx
    - git add .
    - NUM_CHANGED=$(git diff --cached --numstat | wc -l)
    - >
      if [ "$NUM_CHANGED" -eq "0" ]; then
        echo "no static files require updating"
      else
        echo "feat: publish client v$PACKAGE_VERSION" | git commit --allow-empty -F -
        git push
      fi
